package servermsg;

import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;

import application.Status;


public class ResponseRecentUpdates extends ServerMessage {
    
    public static final short TYPE = 52;
    private static final long serialVersionUID = 201009301157L;
    private LinkedList<Status> statuses = null;
    @SuppressWarnings("unused")
	private byte[] Stuff;
    
    public ResponseRecentUpdates(String UsrID, long sentTime, long recvTime, LinkedList<Status> Statuses) {
        super(UsrID, sentTime, recvTime, true);
        statuses = Statuses;
        
        Stuff = new byte[186]; // Make the size of this message comparable to real size of a JTwitter message.
    }
    
    public Status[] getStatusArray() {
        LinkedList<Status> list = getStatuses();
        if(list == null || list.size() == 0) {
            return null;
        } else {
            Collections.sort(list, new StatusTimeComparator());
            int l = list.size();
            Status[] statuses = new Status[l];
            for(int i=0; i<l; i++) {
                statuses[i] = list.get(i);
            }
            return statuses;
        }
    }
    
    public LinkedList<Status> getStatuses() {
        if(statuses == null) {
            return null;
        } else {
            return statuses;
        }
    }
    
    public short getType() {
        return TYPE;
    }
    
    public class StatusTimeComparator implements Comparator<Status> {
        public int compare(Status o1, Status o2) {
            if(o1.getTime() < o2.getTime()) {
                return -1;
            } else if(o1.getTime() == o2.getTime()) {
                return 0;
            } else {
                return 1;
            }
        }
        
    }
}

