package toolBox;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class LogAnalyser {
	
	public static void FindInLogFiles(String ObjectString, String LogDirectory){
		File Folder = null;
		File[] ListOfFolders = null;
		BufferedReader br = null;
		String OneLine = null;
		long NumOfExceptions = 0;
		long NumOfErrors = 0;
		long NumOfObjectStrings = 0;
		
		try{
			Folder = new File(LogDirectory);
			ListOfFolders = Folder.listFiles();
			if(ListOfFolders == null)
				return;
			
			if(ObjectString.equalsIgnoreCase("exception")){ // Find all exceptions in log files
				
				System.out.println("Looking for exceptions in: " + LogDirectory);
				
				for (int NumOfFiles = 0; NumOfFiles < ListOfFolders.length; NumOfFiles++){
					try {
						br = new BufferedReader(new FileReader(ListOfFolders[NumOfFiles]));
					
						while((OneLine = br.readLine()) != null){
							if(OneLine.startsWith("Exception") || OneLine.startsWith("exception")){
								System.out.println("In file: " + ListOfFolders[NumOfFiles].getName());
								System.out.println(OneLine);
								
								br.mark(1024);
								while((OneLine = br.readLine()) != null && !OneLine.startsWith("Info")){
									System.out.println(OneLine);
									br.mark(1024);
								}
								br.reset();
								NumOfExceptions++;
							}
							else if(OneLine.startsWith("Error") || OneLine.startsWith("error")){
									System.out.println("In file: " + ListOfFolders[NumOfFiles].getName());
									System.out.println(OneLine);
									NumOfErrors++;
							}
						}
						
						br.close();
					}catch (IOException e) {
						e.printStackTrace();
						continue;
					}
				} 
				
				System.out.println("In " + LogDirectory + ": Number of exceptions: " + NumOfExceptions + ", Number of errors: " + NumOfErrors);
			
			}else{ // Find other designated object strings in all log files

				System.out.println("Looking for \"" + ObjectString + "\" in: " + LogDirectory);
				
				for (int NumOfFiles = 0; NumOfFiles < ListOfFolders.length; NumOfFiles++){
					try {
						br = new BufferedReader(new FileReader(ListOfFolders[NumOfFiles]));
					
						while((OneLine = br.readLine()) != null){
							if(OneLine.contains(ObjectString)){
								System.out.println("In file: " + ListOfFolders[NumOfFiles].getName());
								System.out.println(OneLine);
								NumOfObjectStrings++;
							}
						}
						
						br.close();
					}catch (IOException e) {
						e.printStackTrace();
						continue;
					}
				}
				
				System.out.println("In " + LogDirectory + ": Number of \"" + ObjectString + "\": " + NumOfObjectStrings);
			}
		}catch(Exception e){
			if(!((e instanceof NullPointerException) && ListOfFolders == null))
				e.printStackTrace();
		}finally{
			if(br != null)
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
		}
	}
}
